using System;
using System.Drawing;
using PowerLanguage.Function;

namespace PowerLanguage.Indicator
{
    [SameAsSymbol(true)]
    public class AverageFCTest2 : IndicatorObject
    {
        private ISeries<Double> m_price;

        private int m_length = 9;

        private AverageFC m_averagefc1;

        private VariableSeries<Double> m_avg;

        private IPlotObject Plot1;

        public AverageFCTest2(object ctx) :
            base(ctx) {}

        private ISeries<Double> price{
            get { return m_price; }
        }

        [Input]
        public int length{
            get { return m_length; }
            set { m_length = value; }
        }

        [Input]
        public int displace { get; set; }

        protected override void Create(){
            m_averagefc1 = new AverageFC(this);
            m_avg = new VariableSeries<Double>(this);
            Plot1 =
                AddPlot(new PlotAttributes("Avg", 0, Color.Yellow,
                                           Color.Empty, 0, 0, true));
        }

        protected override void StartCalc(){
            m_price = Bars.Close;
            m_averagefc1.price = price;
            m_averagefc1.length = new Lambda<Int32>(delegate { return length; });
            m_avg.DefaultValue = 0;
        }

		/*
        protected override void CalcBar(){
            m_avg.Value = m_averagefc1[0];
			Output.WriteLine("{0}, {1}", Bars.Time[0], m_avg.Value);
            Plot1.Set(displace, m_avg.Value);
        }
		*/

		
        protected override void CalcBar(){
			Output.WriteLine("{0}, {1}", Bars.Time[0], m_averagefc1[0]);
            Plot1.Set(displace, m_averagefc1[0]);
        }

	}
}